clear all;
rand('seed',sum(100*clock)); 

tic
numRuns = 1000; %% run the model for 1000 combinations of the receptor numbers being varied
allParamValues = cell(numRuns,1);

for i = 1:numRuns
        modelParams(1,1) = 70;          %BW
        modelParams(2,1) = 6.02E+23;	%Avogadro
        
        modelParams(3,1) = 7.5e-7;      %ECM_conc      
        modelParams(4,1) = 1.3e-5;      %EBM_conc
        modelParams(5,1) = 1.3e-5;      %PBM_conc
        
        modelParams(6,1) = 0.061987;    %ECM_Vol_tis_norm
        modelParams(7,1) = 8.7e-5;      %EBM_Vol_tis_norm
        modelParams(8,1) = 3.07e-4;     %PBM_Vol_tis_norm
        
        modelParams(9,1) = 0.53876;     %ECM_Vol_tis_blood
        modelParams(10,1) = 4.3e-4;     %EBM_Vol_tis_blood
        modelParams(11,1) = 0.00421;    %PBM_Vol_tis_blood
        
        modelParams(12,1) = 0.51931;	%ECM_Vol_tis_dis
        modelParams(13,1) = 0.00027;	%EBM_Vol_tis_dis
        modelParams(14,1) = 0.002446;	%PBM_Vol_tis_dis
        
        modelParams(15,1) = 61321;      %vol_Norm
        modelParams(16,1) = 5000;       %vol_Blood
        modelParams(17,1) = 33.51032;   %vol_Tumor
        modelParams(18,1) = 30;         %vol_Subc
        
        modelParams(19,1) = 1534;       %tumorSA_Vol_tis_dis
        modelParams(20,1) = 105;        %VesselSA_Vol_tis_dis
        modelParams(21,1) = 108;        %VesselSA_Vol_tis_norm
        modelParams(22,1) = 664;        %fiberSA_Vol_tis_norm
        
        modelParams(23,1) = 9.97E-06;	%tumorCellSurfArea_tis_dis
        modelParams(24,1) = 1.00E-05;	%VesselCellSurfArea_blood
        modelParams(25,1) = 1.00E-05;	%VesselCellSurfArea_tis_dis
        modelParams(26,1) = 1.00E-05;	%VesselCellSurfArea_tis_norm
        modelParams(27,1) = 1.85E-05;	%fiberCellSurfArea_tis_norm
       
        modelParams(28,1) = 1;            %qTSP1EC
        modelParams(29,1) = 1;            %qTSP1disEC
        modelParams(30,1) = 1;            %qTSP1tum
        modelParams(31,1) = 0;            %qTSP1myo
        modelParams(32,1) = 5;            %qMMP3_disEC
        modelParams(33,1) = 1.2;          %qproMMP9_disEC
        modelParams(34,1) = 5;            %qMMP3_EC
        modelParams(35,1) = 1.2;          %qproMMP9_EC
        modelParams(36,1) = 12;           %qMMP3tum
        modelParams(37,1) = 24;           %qproMMP9tum
        modelParams(38,1) = 4;            %qMMP3myo
        modelParams(39,1) = 4;            %qproMMP9myo
        modelParams(40,1) = 0.387;        %qV165_tumor
        modelParams(41,1) = 0.387;        %qV121_tumor
        modelParams(42,1) = 0.0324;       %qV165_disEC
        modelParams(43,1) = 0.0324/9;     %qV121_disEC
        modelParams(44,1) = 5.01e-9;      %qV165_myo
        modelParams(45,1) = 5.01e-9*8/92; %qV121_myo
        
        modelParams(46,1) = 6.27760296527124E-14;    %ksyn_a2M
        modelParams(47,1) = 3.13880148263562E-14;    %ksyn_a2M_fast
    
        modelParams(48,1) = 0.00028;	%sR_receptors
        modelParams(49,1) = 0.00028;	%k_int_receptors
        
        
        modelParams(50,1) = 5.00E+05;	%kon_TSP1_GAG
        modelParams(51,1) = 5.00E+05;	%kon_TSP1_CD36
        modelParams(52,1) = 5.00E+05;	%kon_TSP1_CD47
        modelParams(53,1) = 2.10E+05;	%kon_TSP1_LRP1
        modelParams(54,1) = 5.00E+05;	%kon_TSP1_B1
        modelParams(55,1) = 5.00E+05;	%kon_TSP1_VEGF
        modelParams(56,1) = 1.00E+05;	%kon_TSP1_MMP3
        modelParams(57,1) = 3.20E+06;	%kon_V165_N1
        modelParams(58,1) = 1.00E+06;	%kon_V165_N2
        modelParams(59,1) = 3.00E+07;	%kon_V165_R1
        modelParams(60,1) = 1.00E+07;	%kon_V165_R2
        modelParams(61,1) = 8600;       %kon_V165_GAG
        modelParams(62,1) = 3.00E+07;	%kon_V121_R1
        modelParams(63,1) = 1.00E+07;	%kon_V121_R2
        modelParams(64,1) = 9245;	    %kon_MMP9_LRP1
        modelParams(65,1) = 10000;      %kon_MMP3_proMMP9
        modelParams(66,1) = 25;         %kon_VEGF_a2M
        modelParams(67,1) = 250;        %kon_VEGF_a2M_fast
       
        
        modelParams(68,1) = 0.1;        %koff_TSP1_GAG
        modelParams(69,1) = 0.115;      %koff_TSP1_CD36
        modelParams(70,1) = 0.005;      %koff_TSP1_CD47
        modelParams(71,1) = 0.0025;     %koff_TSP1_LRP1
        modelParams(72,1) = 0.05;       %koff_TSP1_B1
        modelParams(73,1) = 0.005;      %koff_TSP1_VEGF
        modelParams(74,1) = 0.0022303;	%koff_TSP1_MMP3
        modelParams(75,1) = 0.001;      %koff_V165_N1
        modelParams(76,1) = 0.001;      %koff_V165_N2
        modelParams(77,1) = 0.001;      %koff_V165_R1
        modelParams(78,1) = 0.001;      %koff_V165_R2
        modelParams(79,1) = 0.00069;	%koff_V165_GAG
        modelParams(80,1) = 0.001;      %koff_V121_R1
        modelParams(81,1) = 0.001;      %koff_V121_R2
        modelParams(82,1) = 0.00049;    %koff_MMP9_LRP1   
        modelParams(83,1) = 0.001;      %koff_MMP3_proMMP9         
        modelParams(84,1) = 1.0E-4;     %koff_VEGF_a2M
        modelParams(85,1) = 1.0E-4;     %koff_VEGF_a2M_fast

               
        modelParams(86,1) = 1.00E+14;      %kc_V165N_R2
        modelParams(87,1) = 3.10E+13;      %kc_V165R2_N
        modelParams(88,1) = 1.00E+14;      %kc_R1_N
        modelParams(89,1) = 3.10E+11;      %kc_CD36_R2
        modelParams(90,1) = 3.10E+13;      %kc_CD36_B1
        modelParams(91,1) = 3.10E+11;      %kc_CD47_R2

        modelParams(92,1) = 0.001;      %kdissoc_R2_N
        modelParams(93,1) = 0.01;       %kdissoc_R1_N
        modelParams(94,1) = 0.001;      %kdissoc_CD36_B1
        modelParams(95,1) = 0.001;      %kdissoc_CD36_R2
        modelParams(96,1) = 0.001;      %kdissoc_CD47_R2
        
        
        modelParams(97,1) = 4.415e-8;    %kdeg_aV
        modelParams(98,1) = 0.000193;    %kdeg_VEGF
        modelParams(99,1) = 0.00033;     %kdeg_TSP1
        modelParams(100,1) = 0.0012;     %kdeg_MMP
        modelParams(101,1) = 1.60E-4;    %kdeg_TSP1mim
        modelParams(102,1) = 3.82E-7;    %c_aV
        modelParams(103,1) = 3.82E-7;    %c_aV_VEGF
        modelParams(104,1) = 0.00107966850554509;    %c_VEGF
        modelParams(105,1) = 0.00033;    %c_TSP1
        modelParams(106,1) = 0.0012;     %c_MMP
        modelParams(107,1) = 1.60E-4;    %c_TSP1mim    
        modelParams(108,1) = 3.85081766977747E-5;    %c_a2M
        modelParams(109,1) = 0.003850817669777;      %c_a2M_fast
       
        modelParams(110,1) = 0.00386;   %k_TSP1cleave
        modelParams(111,1) = 0.0019;    %k_act_MMP3_proMMP9     
        modelParams(112,1) = 631;       %kp_mmp
        
        modelParams(113,1) = 2500;      %CD36_number_tum
        modelParams(114,1) = 10000;     %CD47_number_tum
        modelParams(115,1) = 5000;      %LRP1_number_tum
        modelParams(116,1) = 10000;     %B1_number_tum
        
        modelParams(117,1) = 1250;      %CD36_number_disEC
        modelParams(118,1) = 5000;      %CD47_number_disEC
        modelParams(119,1) = 2500;      %LRP1_number_disEC
        modelParams(120,1) = 5000;      %B1_number_disEC
       
        modelParams(121,1) = 1250;      %CD36_number_normEC
        modelParams(122,1) = 1250;      %CD47_number_normEC
        modelParams(123,1) = 625;       %LRP1_number_normEC
        modelParams(124,1) = 2500;      %B1_number_normEC
          
        modelParams(125,1) = 2500;      %CD36_number_myo      
        modelParams(126,1) = 2500;      %CD47_number_myo
        modelParams(127,1) = 1250;      %LRP1_number_myo
        modelParams(128,1) = 5000;      %B1_number_myo
        
        modelParams(129,1) = 1100;      %R1_number_tum
        modelParams(130,1) = 550;       %R2_number_tum
        modelParams(131,1) = 39500;     %N1_number_tum   
        modelParams(132,1) = 39500;     %N2_number_tum
      
        modelParams(133,1) = 3750;      %R1_number_disEC
        modelParams(134,1) = 300;       %R2_number_disEC
        modelParams(135,1) = 20000;     %N1_number_disEC      
        modelParams(136,1) = 20000;     %N2_number_disEC
        
        modelParams(137,1) = 550;       %R1_number_normEC      
        modelParams(138,1) = 350;       %R2_number_normEC      
        modelParams(139,1) = 17000;     %N1_number_normEC
        modelParams(140,1) = 0;         %N2_number_normEC  
        
        modelParams(141,1) = 0;         %R1_number_myo
        modelParams(142,1) = 0;         %R2_number_myo
        modelParams(143,1) = 34500;     %N1_number_myo
        modelParams(144,1) = 0;         %N2_number_myo
       
        modelParams(145,1) = 0;             %k_lymph_dis
        modelParams(146,1) = 0.033333333;   %k_lymph        
        modelParams(147,1) = 4.0E-7;        %kperm_B_T_VEGF     
        modelParams(148,1) = 4.0E-8;        %kperm_B_N_VEGF
        modelParams(149,1) = 3.0E-7;        %kperm_B_T_aV 
        modelParams(150,1) = 3.0E-8;        %kperm_B_N_aV     
       
        modelParams(151,1) = 0;        %antiVEGF_dosage
        modelParams(152,1) = 150000;   %antiVEGF_MW        
        modelParams(153,1) = 5400;     %infTime_antiVEGF
        modelParams(154,1) = 2.2e-9;   %Kd_V165_antiVEGF
        modelParams(155,1) = 2.2e-9;   %Kd_V121_antiVEGF
        modelParams(156,1) = 2.0e-4;   %Koff_V165_antiVEGF
        modelParams(157,1) = 2.0e-4;   %koff_V121_antiVEGF
         
        
        % parameters to be varied in MC analysis with function samping in
        % unifor distribution findParamValue_Rec(baseline value, upper bound, low bound)
        modelParams(113,1) = findParamValue_Rec(2500,25000,250);	  %CD36_number_tum
        modelParams(114,1) = findParamValue_Rec(10000,100000,1000);	  %CD47_number_tum
        modelParams(115,1) = findParamValue_Rec(5000,50000,500);	  %LRP1_number_tum
        modelParams(116,1) = findParamValue_Rec(10000,100000,1000);	  %B1_number_tum
        
        modelParams(117,1) = findParamValue_Rec(1250,12500,125);      %CD36_number_disEC
        modelParams(118,1) = findParamValue_Rec(5000,50000,500);	  %CD47_number_disEC
        modelParams(119,1) = findParamValue_Rec(2500,25000,250);	  %LRP1_number_disEC
        modelParams(120,1) = findParamValue_Rec(5000,50000,500);	  %B1_number_disEC

        modelParams(129,1) = findParamValue_Rec(1100,11000,110);      %R1_number_tum
        modelParams(130,1) = findParamValue_Rec(550,5500,55);         %R2_number_tum
        modelParams(131,1) = findParamValue_Rec(39500,395000,3950);   %N1_number_tum   
        modelParams(132,1) = findParamValue_Rec(39500,395000,3950);   %N2_number_tum
        
        modelParams(133,1) = findParamValue_Rec(3750,37500,375);      %R1_number_disEC
        modelParams(134,1) = findParamValue_Rec(300,3000,30);         %R2_number_disEC
        modelParams(135,1) = findParamValue_Rec(20000,200000,2000);   %N1_number_disEC      
        modelParams(136,1) = findParamValue_Rec(20000,200000,2000);   %N2_number_disEC
        
        allParamValues{i,1} = modelParams;  
end
toc

%save the sampled parameters
save('Param_TIME.mat');

clear all;
rand('seed',sum(100*clock)); 

tic
%load the sampled paramters
load('Param_TIME');
allResults = cell(numRuns,1);
allDistr = cell(numRuns,1);
allObservables = cell(numRuns,1);


%started the simulation of ABT-510 treatment for 1000 sampled patients
parfor i = 1:numRuns
    if size(allResults{i,1},2) == 0
        modelParams = allParamValues{i,1};            
        % simulate to steady state
        
        stopTime = 24*3600*1; % 1 day
        [err, t, results, observables_out] = TSP1_VEGF_Model(linspace(0,stopTime,100)', [], modelParams', []);
        
        allResults{i,1} = results;
        allObservables{i,1} = observables_out;
        
        % giving the ABT-510 for 14 days
        for di = 1:14
        % % add mimetic - 1st dose in Day1
            
            stopTime2 = stopTime + 24*3600*0.5; 
            initvalue = results(end,:);
            initvalue(1,99) = initvalue(1,99) + 3.35e-6*0.3;
                    
            [err, t2, results2, observables_out2] = TSP1_VEGF_Model(linspace(stopTime,stopTime2,100)', initvalue, modelParams', []);
                       
            allResults{i,1} = [allResults{i,1};results2];
            allObservables{i,1} = [allObservables{i,1};observables_out2];
        % % add mimetic - 2nd dose in Day1
            
            stopTime3 = stopTime2+24*3600*0.5;
            initvalue = results2(end,:);
            initvalue(1,99) = initvalue(1,99) + 3.35e-6*0.3;
            
                     
            [err, t3, results3, observables_out3] = TSP1_VEGF_Model(linspace(stopTime2,stopTime3,100)', initvalue, modelParams', []);
                     
            allResults{i,1} = [allResults{i,1};results3];
            allObservables{i,1} = [allObservables{i,1};observables_out3];
            
            stopTime = stopTime3;
            results = results3;
            
        end   
    end
end

tsim =[linspace(0,24*3600*1,100) linspace(24*3600*1,24*3600*15,2800)]./3600;

ECM_Vol_tis_dis = 0.51931;
EBM_Vol_tis_dis = 0.00027;
PBM_Vol_tis_dis = 0.002446;
    
ECM_Vol_tis_blood =	0.53876;
EBM_Vol_tis_blood =	4.3e-4;
PBM_Vol_tis_blood =	0.00421;
    
ECM_Vol_tis_norm =	0.061987;
EBM_Vol_tis_norm =	8.7e-5;
PBM_Vol_tis_norm =	3.07e-4;
    
Interstit_Vol_tis_dis = ECM_Vol_tis_dis+EBM_Vol_tis_dis+PBM_Vol_tis_dis;
Interstit_Vol_tis_norm = ECM_Vol_tis_norm+EBM_Vol_tis_norm+PBM_Vol_tis_norm;
Interstit_Vol_tis_blood = ECM_Vol_tis_blood+EBM_Vol_tis_blood+PBM_Vol_tis_blood;

toc
disp('CD36 simulation is done!');
save('CD36_MC1000_TIME','-v7.3');

clear all;
%load the sampled paramters
load('Param_TIME');
disp('load parameters value');
allResults = cell(numRuns,1);
allDistr = cell(numRuns,1);
allObservables = cell(numRuns,1);
tic;

%started the simulation of combination treatment for 1000 sampled patients
parfor i = 1:numRuns
    if size(allResults{i,1},2) == 0
        modelParams = allParamValues{i,1};       
        % simulate to steady state
        stopTime = 24*3600*1; % 1 day
        [err, t, results, observables_out] = TSP1_VEGF_Model(linspace(0,stopTime,100)', [], modelParams', []);
        
        allResults{i,1} = results;
        allObservables{i,1} = observables_out;

        % % Bevacizumab infusion time - 1st dose
        parameters = modelParams;
        parameters(151,1) = 10;
        stopTime_AV = stopTime + 5400; %infusion 1.5 hour
        initvalue = results(end,:);
        [err, t_av, results_av, observables_out_av] = TSP1_VEGF_Model(linspace(stopTime,stopTime_AV,100)', initvalue, parameters', []);
        
        allResults{i,1} = [allResults{i,1};results_av];
        allObservables{i,1} = [allObservables{i,1};observables_out_av];
        stopTime = stopTime_AV;
        results = results_av;
        
        % % add mimetic - 1st dose in Day1
            
            stopTime2 = stopTime + 10.5*3600; 
            initvalue = results(end,:);
            initvalue(1,99) = initvalue(1,99) + 3.35e-6*0.3;
                    
            [err, t2, results2, observables_out2] = TSP1_VEGF_Model(linspace(stopTime,stopTime2,100)', initvalue, modelParams', []);
                       
            allResults{i,1} = [allResults{i,1};results2];
            allObservables{i,1} = [allObservables{i,1};observables_out2];
            
        % % add mimetic - 2nd dose in Day1
            
            stopTime3 = stopTime2+12*3600;
            initvalue = results2(end,:);
            initvalue(1,99) = initvalue(1,99) + 3.35e-6*0.3;
            
                     
            [err, t3, results3, observables_out3] = TSP1_VEGF_Model(linspace(stopTime2,stopTime3,100)', initvalue, modelParams', []);
                     
            allResults{i,1} = [allResults{i,1};results3];
            allObservables{i,1} = [allObservables{i,1};observables_out3];
            
            stopTime = stopTime3;
            results = results3;
        
        % % Giving ABT-510 for following 13 days
        for di = 1:13
        % % add mimetic - 1st dose in Day1
            
            stopTime2 = stopTime + 24*3600*0.5; 
            initvalue = results(end,:);
            initvalue(1,99) = initvalue(1,99) + 3.35e-6*0.3;
                    
            [err, t2, results2, observables_out2] = TSP1_VEGF_Model(linspace(stopTime,stopTime2,100)', initvalue, modelParams', []);
                       
            allResults{i,1} = [allResults{i,1};results2];
            allObservables{i,1} = [allObservables{i,1};observables_out2];
        % % add mimetic - 2nd dose in Day1
            
            stopTime3 = stopTime2+24*3600*0.5;
            initvalue = results2(end,:);
            initvalue(1,99) = initvalue(1,99) + 3.35e-6*0.3;
            
                     
            [err, t3, results3, observables_out3] = TSP1_VEGF_Model(linspace(stopTime2,stopTime3,100)', initvalue, modelParams', []);
                     
            allResults{i,1} = [allResults{i,1};results3];
            allObservables{i,1} = [allObservables{i,1};observables_out3];
            
            stopTime = stopTime3;
            results = results3;
            
        end
       
    end
end
toc;
tsim =[linspace(0,22.5*3600*1,100) linspace(22.5*3600*1,24*3600, 100) linspace(24*3600*1,24*3600*15,2800)]./3600;

ECM_Vol_tis_dis = 0.51931;
EBM_Vol_tis_dis = 0.00027;
PBM_Vol_tis_dis = 0.002446;
    
ECM_Vol_tis_blood =	0.53876;
EBM_Vol_tis_blood =	4.3e-4;
PBM_Vol_tis_blood =	0.00421;
    
ECM_Vol_tis_norm =	0.061987;
EBM_Vol_tis_norm =	8.7e-5;
PBM_Vol_tis_norm =	3.07e-4;
    
Interstit_Vol_tis_dis = ECM_Vol_tis_dis+EBM_Vol_tis_dis+PBM_Vol_tis_dis;
Interstit_Vol_tis_norm = ECM_Vol_tis_norm+EBM_Vol_tis_norm+PBM_Vol_tis_norm;
Interstit_Vol_tis_blood = ECM_Vol_tis_blood+EBM_Vol_tis_blood+PBM_Vol_tis_blood;
disp('CB simulation is done!');
save('CB_MC1000_TIME','-v7.3');

clear all;
%load the sampled paramters
load('Param_TIME');
disp('load parameters value');
allResults = cell(numRuns,1);
allDistr = cell(numRuns,1);
allObservables = cell(numRuns,1);
tic;

%started the simulation of Bevacizumab treatment for 1000 sampled patients
parfor i = 1:numRuns
    if size(allResults{i,1},2) == 0
        modelParams = allParamValues{i,1};  
        
        % simulate to steady state
        stopTime = 24*3600*1; % 1 day
        [err, t, results, observables_out] = TSP1_VEGF_Model(linspace(0,stopTime,100)', [], modelParams', []);
        
        allResults{i,1} = [allResults{i,1};results];
        allObservables{i,1} = [allObservables{i,1};observables_out];
        % % infusion time - 1st dose
        parameters = modelParams;
        parameters(151,1) = 10;
        stopTime2 = stopTime + 5400; %infusion 1.5 hour
        initvalue = results(end,:);
        [err, t2, results2, observables_out2] = TSP1_VEGF_Model(linspace(stopTime,stopTime2,100)', initvalue, parameters', []);
        allResults{i,1} = [allResults{i,1};results2];
        allObservables{i,1} = [allObservables{i,1};observables_out2];
        % following 2 weeks
        stopTime3 = stopTime2+(22.5+13*24)*3600; 
        initvalue = results2(end,:);
        [err, t3, results3, observables_out3] = TSP1_VEGF_Model(linspace(stopTime2,stopTime3,2800)', initvalue, modelParams', []);
        allResults{i,1} = [allResults{i,1};results3];
        allObservables{i,1} = [allObservables{i,1};observables_out3];
    end
end
toc;
tsim =[linspace(0,24*3600*1,100) linspace(24*3600*1,24*3600*1+5400,100) linspace(24*3600*1+5400,15*24*3600,2800)]./3600 ;

ECM_Vol_tis_dis = 0.51931;
EBM_Vol_tis_dis = 0.00027;
PBM_Vol_tis_dis = 0.002446;
    
ECM_Vol_tis_blood =	0.53876;
EBM_Vol_tis_blood =	4.3e-4;
PBM_Vol_tis_blood =	0.00421;
    
ECM_Vol_tis_norm =	0.061987;
EBM_Vol_tis_norm =	8.7e-5;
PBM_Vol_tis_norm =	3.07e-4;
    
Interstit_Vol_tis_dis = ECM_Vol_tis_dis+EBM_Vol_tis_dis+PBM_Vol_tis_dis;
Interstit_Vol_tis_norm = ECM_Vol_tis_norm+EBM_Vol_tis_norm+PBM_Vol_tis_norm;
Interstit_Vol_tis_blood = ECM_Vol_tis_blood+EBM_Vol_tis_blood+PBM_Vol_tis_blood;

disp('AV simulation is done!');
save('AV_MC1000_TIME','-v7.3');


